
      INCLUDE  'FGRAPH.FI'
      INCLUDE  'FGRAPH.FD'

	INTEGER*1      Lik,Likov,Iz,ZuNo,zt,n,m
	INTEGER        i,j,l,vu
	INTEGER*2      dummy2,cp,status
	CHARACTER*8    Izpis
	CHARACTER*70   str
	REAL	       X,Y,B,OD(5),OR(5),Xk,Yk,Ik,Jk,Tx,Ty,flg,R
	REAL	       v1x,v1y,v2x,v2y,v1a,v2a,xo1,yo1,xo2,yo2,	! Vektorji
     -		       v1ex,v1ey,v2ex,v2ey,vo1x,vo1y,vo2x,vo2y,Ol
	REAL	       MSk(3,3) /8*.0,1.0/
	REAL	       MPr(3,3) /1.0,3*.0,1.0,3*.0,1.0/
	REAL	       MCo(3,3) /9*.0/,TCo(3,3)
	CHARACTER*3    Ukaz,Tem
	COMMON /Vekt/  v1x,v1y,v2x,v2y,v1a,v2a,xo1,yo1,xo2,yo2,
     -		       v1ex,v1ey,v2ex,v2ey,vo1x,vo1y,vo2x,vo2y
	COMMON /GlPar/ X(5,100),Y(5,100),B(5,100),Lik(5),Likov,n
	COMMON /Gcode/ Ukaz(300),Xk(300),Yk(300),
     -		       Ik(300),Jk(300),i,j,l,Tx,Ty
	RECORD /rccoord/ curpos,rc
	RECORD /wxycoord/ wxy

      CALL ZapDat               ! Zapi{e Datoteko CNC.TXT
      CALL PlOr(Iz,ZuNo,OD,OR)	! Plo{~ina, orientacija, dolo~itev parametrov
      CALL Meje(Xz,Yz,dX,dY,OD(1),ZuNo) ! Dolo~i meje lika, potr. za transfor.
      CALL Skal(dX,dY,MSk,Iz,Sx,Sy)	! Skaliranje lika
      CALL Premik(-(Xz+dX/2),-(Yz+dY/2),MPr)	! Premik v izhodi{~e
      CALL Comp(MCo,MSk,MPr)
      CALL Premik(320.0,207.0,MPr)		! Premik na sredo
      TCo=MCo
      CALL Comp(MCo,MPr,TCo)			! Kompozitna matrika
      CALL gopks()				! Dolo~itev zaslona
      CALL gswkvp(1,0.0,1.0,640.0,478.0)
      CALL gswn(1,0.0,0.0,640.0,478.0)
      CALL IzrisLi(MCo,Sx,Sy)			! Izri{i lik
**    OBRAVNAVA LIKA---------------------------------------------------------
      DO 101 m=1,Likov
       Ukaz(1)='G90'
       Ukaz(2)='G17'
**     PRVI UKAZ-------------------------------------------------------------
       i=4
       j=1
       l=1
       flg=1.0
       Ukaz(3)='G00'
       zt=Lik(m)
       IF (B(m,zt).EQ.0.0) THEN
	CALL Vektorji(X(m,zt),Y(m,zt),X(m,zt+1),Y(m,zt+1),
     -	X(m,zt+2),Y(m,zt+2),OD(m),OR(m))
	Xk(1)=X(m,zt)+vo1x
	Yk(1)=Y(m,zt)+vo1y
       ELSE
	CALL ParLoka(B(m,zt),X(m,zt),Y(m,zt),X(m,zt+1)-X(m,zt),
     -	Y(m,zt+1)-Y(m,zt),OD(m),OR(m),Flg,Skx,Sky,Rxo,Ryo,R,Orl)
	Xk(1)=X(m,zt)+Rxo
	Yk(1)=Y(m,zt)+Ryo
       ENDIF
       Tx=Xk(1)
       Ty=Yk(1)
       n=Lik(m)
       CALL Obravnavaj(m,zt,OD(m),OR(m),n)
       Xk(1)=Tx
       Yk(1)=Ty
       n=1
       i=4
       j=2
       l=1
       IF (B(m,n).NE.0.0) THEN
	Ukaz(4)='G91'
	i=5
       ENDIF
**     ----------------------------------------------------------------------
       DO WHILE(n.NE.Lik(m)+1)
        CALL Obravnavaj(m,n,OD(m),OR(m),zt)
	n=n+1
       ENDDO
       Ukaz(i)='M30'
101   CONTINUE
**    IZPIS G-CODE----------------------------------------------------------
      open(unit=25, file='cnc.g', status='unknown')
      j=1
      l=1
      Tx=0
      Ty=0
      cp=1
      CALL settextwindow(1,2,4,80)
      status=setcolor(6)
      status=rectangle( $GBORDER,0,64, 639, 477)
      CALL moveto_w(0,414,wxy)
      dummy2=lineto_w(639,414)
      Do 40 k=1,i-1
       status=setcolor(6)
       status=rectangle( $GBORDER,0,0, 639, 63)
       dummy2=settextcolor(7)
       CALL settextposition( cp, 2, curpos )
       CALL gsplci(4)
       Tem=Ukaz(k)
       vu=ICHAR(Tem(2:2))+ICHAR(Tem(3:3))
       SELECT CASE (vu)
	CASE (104,105,106)		     ! G90,G91,G17
	  str=Ukaz(k)
          CALL outtext(str)
          write(25, *) str
	CASE (96,97)			     ! G00,G01
	  str=Ukaz(k)//' X'//Izpis(Xk(j))//' Y'//Izpis(Yk(j))
	  dummy2 = settextcolor(9)
          CALL outtext(str)
          write(25, *) str
	  IF (vu.EQ.96) THEN
	   CALL gsplci(2)
	  ENDIF
	  CALL IzrisDal(Tx,Ty,Xk(j),Yk(j),MCo)
	  Tx=Xk(j)
	  Ty=Yk(j)
	  READ(*,*)
	  j=j+1
	 CASE (98,99)			     ! G02,G03
	  str=Ukaz(k)//' X'//Izpis(Xk(j))//' Y'//Izpis(Yk(j))//
     -	  ' I'//Izpis(Ik(l))//' J'//Izpis(Jk(l))
	  dummy2 = settextcolor(9)
          CALL outtext(str)
          write(25, *) str
	  Ol=1.0
	  IF (vu.EQ.98) THEN
	   Ol=-1.0
	  ENDIF
	  R=SQRT(Ik(l)**2+Jk(l)**2)
	  CALL IzrisLok(Sx,Sy,Tx,Ty,Xk(j)*Sx,Yk(j)*Sy,
     -	  Ik(l)*Sx,Jk(l)*Sy,Ol,MCo,R)
	  Tx=Tx+Xk(j)
	  Ty=Ty+Yk(j)
	  READ(*,*)
	  j=j+1
	  l=l+1
       END SELECT
       CALL gettextposition( rc )
       IF ((rc.row.EQ.4).OR.(k.EQ.3)) THEN
	dummy2 = settextcolor(7)
	CALL settextposition( cp, 2, curpos )
        CALL outtext(str)
	IF (k.NE.3) THEN
	 CALL scrolltextwindow( 1 )
	ENDIF
       ENDIF
       cp=cp+1
40    CONTINUE
      str=Ukaz(i)
      CALL settextposition( 4, 2, curpos )
      CALL outtext(str)
      write(25, *) str
      status = rectangle( $GBORDER, 0, 0, 639, 63)
      CALL gclks()
      close(25)

      END

***Podprogram Obravnavaj obravnava vrsto sosednjih posplo{enih daljic in*****
***temu ustrezno kli~e pravi podprogram.*************************************

      SUBROUTINE Obravnavaj(m,no,ODO,ORT,zt)

       INTEGER*1   Lik(5),Likov,no,n,m,zt
       REAL	   X(5,100),Y(5,100),B(5,100),ODO,ORT
       COMMON	   /GlPar/ X,Y,B,Lik,Likov,n

	IF (no.EQ.1) THEN
	 Lik(m)=Lik(m)-1
	ELSE
	 Lik(m)=zt
	ENDIF
	IF ((B(m,no).EQ.0.0).AND.(B(m,no+1).EQ.0.0)) CALL DD(X(m,no),
     -	 Y(m,no),X(m,no+1),Y(m,no+1),X(m,no+2),Y(m,no+2),ODO,ORT)

	IF ((B(m,no).EQ.0.0).AND.(B(m,no+1).NE.0)) CALL DL(B(m,no+1),
     -	 X(m,no),Y(m,no),X(m,no+1),Y(m,no+1),X(m,no+2),Y(m,no+2),
     -	 ODO,ORT)

	IF ((B(m,no).NE.0.0).AND.(B(m,no+1).EQ.0.0))  CALL LD(B(m,no),
     -	X(m,no),Y(m,no),X(m,no+1),Y(m,no+1),X(m,no+2),Y(m,no+2),
     -	ODO,ORT)

	IF ((B(m,no).NE.0.0).AND.(B(m,no+1).NE.0.0)) CALL LL(B(m,no),
     -	B(m,no+1),X(m,no),Y(m,no),X(m,no+1),Y(m,no+1),X(m,no+2),
     -	Y(m,no+2),ODO,ORT)
      RETURN
      END

***Funkcija levo poravna izpis realnih {tevil.*******************************

      CHARACTER*8 FUNCTION Izpis(r)

       CHARACTER*8 Iz

      WRITE(Iz,'(F8.2)') r
      j=1
      DO 10 i=1,8
       Izpis(i:i)=' '
       IF (Iz(i:i).NE.' ') THEN
	Izpis(j:j)=Iz(i:i)
	j=j+1
       ENDIF
10    CONTINUE
      RETURN
      END

***Podprogram odpre datoteko CNC.TXT ter zapi{e koordinate, ki so v njej.***
***Podprogram zapi{e tudi {tevilo likov, ki se nahajajo v datoteki.**********

      SUBROUTINE ZapDat

	INTEGER    i,k
	INTEGER*1  Lik(5),Likov,n
	REAL	   X(5,100),Y(5,100),B(5,100)
	COMMON	   /GlPar/ X,Y,B,Lik,Likov,n

      OPEN (27, ERR=1000, FILE='CNC.TXT', STATUS='OLD')
      i=1
      READ(27,*) Lik(i)
      DO WHILE (Lik(i).NE.0)
	 DO 10 k=1,Lik(i)
	  READ(27,*) X(i,k), Y(i,k), B(i,k)
10	 CONTINUE
       i=i+1
       READ(27,*) Lik(i)
      ENDDO
      Likov=i-1
      CLOSE(27)
      RETURN
1000  STOP 'Datoteke CNC.TXT ne najdem!'
      END

***Podprogram izpi{e plo{~ino in orientacijo lika. Nastavi tudi odmik ter****
***dolo~i zunanji rez ali notranje frezanje.*********************************

      SUBROUTINE DolOdRe(k,A,Iz,ZuNo,OD,OR)

	INTEGER*1    Iz,ZuNo
	REAL	     OD(5),OR(5)
	CHARACTER*1  ZN

      WRITE(*,21) k,A
21    FORMAT(' Plo{~ina lika',I3,' je',F7.1)
      IF (OR(k).eq.-1) THEN
	 WRITE(*,22) k
22	 FORMAT(' Lik',I3,' je podan v smeri urinega kazalca')
       ELSE
	 WRITE(*,23) k
23	 FORMAT(' Lik',I3,' je podan v obratni smeri urinega kazalca')
      ENDIF
24    WRITE(*,25)
25    FORMAT(' 1=Zun. avtogeno razanje, 2=Notr. frezanje',' > ',\)
      READ(*,'(A1)') ZN
      IF (ICHAR(ZN).EQ.49) THEN
       ELSE IF (ICHAR(ZN).EQ.50) THEN
	 OR(k)=-1*OR(k)
       ELSE
	 WRITE(*,*) 'Podaj 1 ali 2!'
	 GOTO 24
      ENDIF
      ZuNo=ICHAR(ZN)
26    WRITE(*,27) k
27    FORMAT(' Dolo~i odmik za lik',I3,' > ',\)
      READ(0, FMT='(F8.0)', ERR=1010) OD(k)
      IF (OD(k).LT.0.0) THEN
	WRITE(*,*) 'Odmik mora biti pozitivno {tevilo'
	GOTO 26
      ENDIF
      WRITE(*,*)
      WRITE(*,*) 'IZBERI NA^IN IZRISA LIKA!'
      WRITE(*,*) '<1> Mere lika pri izrisu naj ostanejo proporcionalne'
      WRITE(*,*) '<2> Mere lika naj se prilagodijo velikosti okna'
28    WRITE(*,'('' > '',\)')
      READ(0, FMT='(I1)', ERR=1020) Iz
      IF ((Iz.EQ.1).OR.(Iz.EQ.2)) THEN
       CONTINUE
      ELSE
       GOTO 1020
      ENDIF
      RETURN
1010  WRITE(*,*) 'Podaj REALNO pozitivno {tevilo! '
      GOTO 26
1020  WRITE(*,*) 'Podaj 1 ali 2'
      GOTO 28
      END

***Podprogram izra~una plo{~ino ter orientacijo lika. Kli~e tudi podprogram**
***DolOdRe, ki te parametre izpi{e in dolo~i ostale parametre.***************

      SUBROUTINE PlOr(Iz,ZuNo,OD,OR)

	INTEGER*1	Lik(5),Likov,Iz,ZuNo,n
	REAL		X(5,100),Y(5,100),B(5,100),OD(5),OR(5),A
	COMMON /GlPar/	X,Y,B,Lik,Likov,n

      DO 30 k=1,Likov
       X(k,Lik(k)+1)=X(k,1)	      ! Zadnja koordinata mora
       Y(k,lik(k)+1)=Y(k,1)	      ! biti enaka prvi!
       B(k,Lik(k)+1)=B(k,1)
       X(k,Lik(k)+2)=X(k,2)	      ! Potrebno za glavni program
       Y(k,Lik(k)+2)=Y(k,2)
	 DO 20 i=1,Lik(k)
	  A=A+(X(k,i)*Y(k,i+1)-X(k,i+1)*Y(k,i))
20	 CONTINUE
       OR(k)=A/ABS(A)
       A=A/2
       CALL DolOdRe(k,A,Iz,ZuNo,OD,OR)
       A=0
30    CONTINUE
      RETURN
      END

***Podprogram vektorji dolo~i vektorje, enotske vektorje, dol`ine vektorjev,**
***vektorje odmika in to~ke odmika.*******************************************

      SUBROUTINE Vektorji(xk1,yk1,xk2,yk2,xk3,yk3,Odmik,Orn)

	COMMON /Vekt/ v1x,v1y,v2x,v2y,v1a,v2a,xo1,yo1,xo2,yo2,
     -		      v1ex,v1ey,v2ex,v2ey,vo1x,vo1y,vo2x,vo2y

      v1x=xk2-xk1	      ! Vektorja
      v1y=yk2-yk1
      v2x=xk3-xk2
      v2y=yk3-yk2
      v1a=SQRT(v1x**2+v1y**2) ! Dol`ina vektorjev
      v2a=SQRT(v2x**2+v2y**2)
      v1ex=v1x/v1a	      ! Enotska vektorja
      v1ey=v1y/v1a
      v2ex=v2x/v2a
      v2ey=v2y/v2a
      vo1x=v1ey*Odmik*Orn     ! Vektorja odmika
      vo1y=-v1ex*Odmik*Orn
      vo2x=v2ey*Odmik*Orn
      vo2y=-v2ex*Odmik*Orn
      xo1=xk2+vo1x	      ! To~ki odmika
      yo1=yk2+vo1y
      xo2=xk2+vo2x
      yo2=yk2+vo2y
      RETURN
      END

***Podrogram PrePr poi{~e presek dveh premic.********************************

      SUBROUTINE PrePr(Xz1,Yz1,Xz2,Yz2,vx1,vy1,vx2,vy2,s,t,na)

       REAL s,na,dol2,t

      dol2=SQRT(vx2**2+vy2**2)
      na=0.0
      IF (ABS((vy1*vx2-vx1*vy2)/dol2).LT.0.005) THEN	! Preseka ni!
       na=1.0
       RETURN
      ENDIF
      t=((Xz1-Xz2)*vy1-(Yz1-Yz2)*vx1)/(vy1*vx2-vx1*vy2)
      s=((Xz2-Xz1)*vy2-(Yz2-Yz1)*vx2)/(vy2*vx1-vx2*vy1)
      RETURN
      END

****Podprogram daljica - daljica testira lego dveh vektorjev (daljic) in*****
****temu usterzno izra~una presek premic ali zaokro`itev z lokom.************

      SUBROUTINE DD(xk1,yk1,xk2,yk2,xk3,yk3,Odmik,Orn)

	INTEGER        tip
	INTEGER*1      Lik(5),Likov,n
	REAL	       Xk(300),Yk(300),Ik(300),Jk(300),Test,Tx,Ty,Iko,
     -		       Jko,Xko,Yko,Xov,Yov,X(5,100),Y(5,100),B(5,100)
	CHARACTER*3    Ukaz(300)
	COMMON /Vekt/  v1x,v1y,v2x,v2y,v1a,v2a,xo1,yo1,xo2,yo2,
     -		       v1ex,v1ey,v2ex,v2ey,vo1x,vo1y,vo2x,vo2y
	COMMON /Gcode/ Ukaz,Xk,Yk,Ik,Jk,i,j,l,Tx,Ty
	COMMON /GlPar/ X,Y,B,Lik,Likov,n

      CALL Vektorji(xk1,yk1,xk2,yk2,xk3,yk3,Odmik,Orn)
      Ukaz(i)='G01'			! Skupno
      Ukaz(i+1)='G91'
      CALL KontrG01(Tx,Ty,xo1,yo1,Odmik,Xov,Yov,tip,orn)
      Xk(j)=Xov
      Yk(j)=Yov
      SELECT CASE(tip)
      CASE(1)
       IF (B(1,n).NE.0.0) THEN
	i=i+1
       ENDIF
       n=n-1
       Tx=Xk(j)				! Zapomini si zadnjo absolutno koor.
       Ty=Yk(j)
       i=i+1
       j=j+1
       RETURN
      CASE(2)
       CALL ParZao(Xko,Yko,Iko,Jko,Xov,Yov,Odmik,Orn)
       CALL LokZao(Xk(j),Yk(j),Xko,Yko,Iko,Jko,Orn,Odmik,2)
       RETURN
      END SELECT
      Test=v2a*(vo1x*vo2y-vo2x*vo1y)/(Odmik**2)*Orn
      IF (Test.GT.0.005) THEN		! Daljica - lok - daljica
	 CALL LokZao(Xk(j),Yk(j),vo2x-vo1x,vo2y-vo1y,-vo1x,-vo1y,
     -	 Orn,Odmik,2)
      ELSE IF (Test.LT.-0.005) THEN	! Daljica - presek - daljica
	 CONTINUE
      ELSE				! Daljici sta vzporedni
	 IF ((v1ex*v2ex+v1ey*v2ey).LT.0.0) THEN	 ! Kot 180 - zaokro`itev
	  CALL LokZao(Xk(j),Yk(j),vo2x-vo1x,vo2y-vo1y,-vo1x,-vo1y,
     -	  Orn,Odmik,2)
	 ELSE
	  Tx=Xk(j)
	  Ty=Yk(j)
	  i=i+1
	  j=j+1
	 ENDIF
      ENDIF
      RETURN
      END

***Podbrogram dolo~i vse potrbne parametre loka: Radij, sredi{~e, odmik.*****

      SUBROUTINE ParLoka(Uk,x,y,vx,vy,Odm,Ori,Flg,Skx,Sky,Rxo,Ryo,R,Orl)

	REAL	      x,y,vex,vey,vx,vy,va,Flg,Odm,Ori
	REAL	      l,mx,my,Skx,Sky,Rx,Ry,R,Rxo,Ryo,Orl

      va=SQRT(vx**2+vy**2)
      vex=vx/va
      vey=vy/va
      l=va*(1-Uk**2)/(4*Uk)
      Orl=Uk/ABS(Uk)		! Orientacija loka
      mx=-vey*l			! Rotacija enotskega vektorja
      my=vex*l
      Skx=x+vx/2+mx             ! Sredi{~e loka
      Sky=y+vy/2+my
      Rx=vx/2*Flg+mx		! Flag poda prvi ali drugi radij vektor
      Ry=vy/2*Flg+my
      R=SQRT(Rx**2+Ry**2)	! Radij prvotnega loka
      Rxo=Rx/R*Odm*(-Orl)*Ori	! Odmik po radiju
      Ryo=Ry/R*Odm*(-Orl)*Ori
      R=R+Odm*Orl*Ori		! Radij odmaknjenega loka
      RETURN
      END

****************Podprogram poi{~e presek loka in daljice*********************


      SUBROUTINE PresekLD(vx,vy,Xz,Yz,R,Xs,Ys,Orl,Orn,se,Flag,na,s2)

      REAL a,b,c,D,Xn,Yn,se,Flag,na,s2

      Xn=Xz-Xs
      Yn=Yz-Ys
      a=vx**2+vy**2
      b=2*(Xn*vx+Yn*vy)
      c=Xn**2+Yn**2-R**2
      D=b**2-4*a*c
      na=0.0
      IF (D.LE.0.0) THEN
	 na=1.0
	 RETURN
      ENDIF
      se=(-b-SQRT(D)*Orl*Orn*Flag)/(2*a)
      s2=(-b+SQRT(D))/(2*a)		     ! Potrebno za podprogram kontrola
      RETURN
      END

****Podprogram daljica - lok testira medsebojno lego daljice in loka*********
****ter temu ustrezno izra~una presek ali zaokro`itev************************

      SUBROUTINE DL(Uk,xk1,yk1,xk2,yk2,xk3,yk3,Odmik,Orn)

	INTEGER        tip
	INTEGER*1      Lik(5),Likov,n
	REAL	       Test,co,Tx,Ty,Skx,Sky,R,Rxo,Ryo,fl,orl
	REAL	       Xk(300),Yk(300),Ik(300),Jk(300),Iko,Jko,
     -		       X(5,100),Y(5,100),B(5,100)
	CHARACTER*3    Ukaz(300)
	COMMON /Vekt/  v1x,v1y,v2x,v2y,v1a,v2a,xo1,yo1,xo2,yo2,
     -		       v1ex,v1ey,v2ex,v2ey,vo1x,vo1y,vo2x,vo2y
	COMMON /Gcode/ Ukaz,Xk,Yk,Ik,Jk,i,j,l,Tx,Ty
	COMMON /GlPar/ X,Y,B,Lik,Likov,n

      fl=1.0
      CALL Vektorji(xk1,yk1,xk2,yk2,xk3,yk3,Odmik,Orn)		 ! Izr. vekt.
      CALL ParLoka(Uk,x2,y2,v2x,v2y,Odmik,Orn,fl,Skx,Sky,Rxo,Ryo,R,Orl)
      Ukaz(i)='G01'			 ! Skupno
      Ukaz(i+1)='G91'
      CALL KontrG01(Tx,Ty,xo1,yo1,Odmik,Xov,Yov,tip,orn)
      Xk(j)=Xov
      Yk(j)=Yov
      SELECT CASE(tip)
      CASE(1)
       IF (B(1,n).NE.0.0) THEN
	i=i+1
       ENDIF
       n=n-1
       Tx=Xk(j)				 ! Zadnja abs. koor.
       Ty=Yk(j)
       i=i+1
       j=j+1
       RETURN
      CASE(2)
       CALL ParZao(Xko,Yko,Iko,Jko,Xov,Yov,Odmik,Orn)
       CALL LokZao(Xk(j),Yk(j),Xko,Yko,Iko,Jko,Orn,Odmik,2)
       RETURN
      END SELECT
      Test=v2a*(vo1x*Ryo-vo1y*Rxo)/(Odmik**2)*Orn
      IF (Test.LT.-0.005) THEN		 ! Poi{~i presek loka in daljice
	 CONTINUE
      ELSE IF (Test.GT.0.005) THEN	 ! Zaokro`itev
	 CALL LokZao(Xk(j),Yk(j),Rxo-vo1x,Ryo-vo1y,-vo1x,-vo1y,
     -	 Orn,Odmik,2)
      ELSE				 ! Kot 0 - daljica - cos(x)=1
	 Co=(vo1x*Rxo+vo1y*Ryo)/Odmik**2 ! Kot 180 - zaokro`itev - cos(x)=-1
	 IF (Co.LT.0.0) THEN
	    CALL LokZao(Xk(j),Yk(j),Rxo-vo1x,Ryo-vo1y,-vo1x,-vo1y,
     -	    Orn,Odmik,2)
	 ELSE
	    Tx=Xk(j)
	    Ty=Yk(j)
	    i=i+2
	    j=j+1
	 ENDIF
      ENDIF
      RETURN
      END

****Podprogram lok - daljica testira medsebojno lego loka in daljice*********
****ter temu ustrezno izra~una presek ali zaokro`itev************************

      SUBROUTINE LD(Uk,xk1,yk1,xk2,yk2,xk3,yk3,Odmik,Orn)

	INTEGER        tip
	INTEGER*1      Lik(5),Likov,n
	REAL	       Test,co,Tx,Ty,Skx,Sky,R,Rxo,Ryo,fl,orl
	REAL	       Xk(300),Yk(300),Ik(300),Jk(300),X(5,100),
     -		       Y(5,100),B(5,100),Iko,Jko
	CHARACTER*3    Ukaz(300)
	COMMON /Vekt/  v1x,v1y,v2x,v2y,v1a,v2a,xo1,yo1,xo2,yo2,
     -		       v1ex,v1ey,v2ex,v2ey,vo1x,vo1y,vo2x,vo2y
	COMMON /Gcode/ Ukaz,Xk,Yk,Ik,Jk,i,j,l,Tx,Ty
	COMMON /GlPar/ X,Y,B,Lik,Likov,n

      fl=-1.0
      CALL Vektorji(xk1,yk1,xk2,yk2,xk3,yk3,Odmik,Orn)		  ! Izr. vekt.
      CALL ParLoka(Uk,xk1,yk1,v1x,v1y,Odmik,Orn,
     -fl,Skx,Sky,Rxo,Ryo,R,Orl)
      Ukaz(i)='G02'			 ! Smer loka podaja orientacija loka
      IF (Orl.EQ.1.0) THEN
       Ukaz(i)='G03'
      ENDIF
      Ukaz(i+1)='G90'
      CALL KontrG23(Tx,Ty,xk2-Tx+Rxo,yk2-Ty+Ryo,Skx-Tx,Sky-Ty,
     -odmik,Orl,Xov,Yov,tip,orn)
      Xk(j)=Xov-Tx
      Yk(j)=Yov-Ty
      Ik(l)=Skx-Tx
      Jk(l)=Sky-Ty
      SELECT CASE(tip)
      CASE(1)
       IF (B(1,n).NE.0.0) THEN
	i=i-1
       ENDIF
       n=n-1
       Tx=Tx+Xk(j)
       Ty=Ty+Yk(j)
       i=i+2
       j=j+1
       l=l+1
       RETURN
      CASE(2)
       CALL ParZao(Xko,Yko,Iko,Jko,Xov,Yov,Odmik,Orn)
       CALL LokZao(Tx+Xk(j),Ty+Yk(j),Xko,Yko,Iko,Jko,Orn,Odmik,1)
       RETURN
      END SELECT
      Test=v2a*(Rxo*vo2y-Ryo*vo2x)/(Odmik**2)*Orn
      IF (Test.LT.-0.005) THEN		 ! Poi{~i presek loka in daljice
	 CONTINUE
      ELSE IF (Test.GT.0.005) THEN	 ! Zaokro`itev
	 CALL LokZao(Tx+Xk(j),Ty+Yk(j),vo2x-Rxo,vo2y-Ryo,-Rxo,-Ryo,
     -	 Orn,Odmik,1)
      ELSE				   ! Kot 0 - lok - cos(x)=1
	 Co=(vo2x*Rxo+vo2y*Ryo)/(Odmik**2) ! Kot 180 - zaokro`itev - cos(x)=-1
	 IF (Co.LT.0.0) THEN
	    CALL LokZao(Tx+Xk(j),Ty+Yk(j),vo2x-Rxo,vo2y-Ryo,-Rxo,-Ryo,
     -	    Orn,Odmik,1)
	 ELSE
	  Tx=Tx+Xk(j)
	  Ty=Ty+Yk(j)
	  i=i+2
	  j=j+1
	  l=l+1
	 ENDIF
      ENDIF
      RETURN
      END

***Podprogram izra~una presek dveh kro`nic. Ker so za X koordinato {tiri*****
***re{itve jih je potrebno kontrolirati.*************************************

      SUBROUTINE PKro(Skx,Sky,Skx1,Sky1,R,R1,Xp1,Yp1,Xp2,Yp2,na)

	REAL a,b,c,Xzp,Yzp,Xp1,Yp1,Xp2,Yp2,na,fl,s1,s2

      a=-2*(Skx1-Skx)
      b=2*(Sky1-Sky)
      c=-(Skx**2-Skx1**2+Sky**2-Sky1**2+R1**2-R**2)
      na=0
      IF ((a.EQ.0.0).AND.(b.EQ.0.0)) THEN
       na=1.0
       RETURN
      ENDIF
      IF (a.EQ.0.0) THEN
       Xzp=0
       Yzp=c/b
      ELSE
       Xzp=-c/a
       Yzp=0
      ENDIF
      fl=1.0
      CALL PresekLD(b,a,Xzp,Yzp,R,Skx,Sky,fl,fl,s1,fl,na,s2)
      Xp1=Xzp+s1*b
      Yp1=Yzp+s1*a
      Xp2=Xzp+s2*b
      Yp2=Yzp+s2*a
      RETURN
      END

***Podprogram lok - lok testira medsebojno lego in orientacijo dveh lokov.***
***Temu ustrezno izra~una presek dveh kro`nic oziroma dolo~i zaokro`itev.****

      SUBROUTINE LL(Uk,Uk1,xk1,yk1,xk2,yk2,xk3,yk3,Odmik,Orn)

	INTEGER        tip
	INTEGER*1      Lik(5),Likov,n
	REAL	       Test,Tx,Ty,Skx1,Sky1,Rxo1,Ryo1,R1
	REAL	       Xk(300),Yk(300),Ik(300),Jk(300),fl
	REAL	       Skx,Sky,R,Rxo,Ryo,co,Orl1,orl,
     -		       X(5,100),Y(5,100),B(5,100),Iko,Jko
	CHARACTER*3    Ukaz(300)
	COMMON /Vekt/  v1x,v1y,v2x,v2y,v1a,v2a,xo1,yo1,xo2,yo2,
     -		       v1ex,v1ey,v2ex,v2ey,vo1x,vo1y,vo2x,vo2y
	COMMON /Gcode/ Ukaz,Xk,Yk,Ik,Jk,i,j,l,Tx,Ty
	COMMON /GlPar/ X,Y,B,Lik,Likov,n

      fl=1.0
      CALL Vektorji(xk1,yk1,xk2,yk2,xk3,yk3,Odmik,Orn)		  ! Izr. vekt.
      CALL ParLoka(Uk1,xk2,yk2,v2x,v2y,Odmik,Orn,fl,
     -		   Skx1,Sky1,Rxo1,Ryo1,R1,Orl1)
      CALL ParLoka(Uk,xk1,yk1,v1x,v1y,Odmik,Orn,-fl,
     -Skx,Sky,Rxo,Ryo,R,Orl)
      Test=v2a*(Rxo*Ryo1-Ryo*Rxo1)/(Odmik**2)*Orn
      Ukaz(i)='G02'			! Smer loka podaja orientacija loka
      IF (Orl.EQ.1) THEN
       Ukaz(i)='G03'
      ENDIF
      CALL KontrG23(Tx,Ty,xk2-Tx+Rxo,yk2-Ty+Ryo,Skx-Tx,Sky-Ty,
     -odmik,Orl,Xov,Yov,tip,orn)
      Xk(j)=Xov-Tx
      Yk(j)=Yov-Ty
      Ik(l)=Skx-Tx
      Jk(l)=Sky-Ty
      SELECT CASE(tip)
      CASE(1)
       IF (B(1,n).EQ.0.0) THEN
	Ukaz(i+1)='G90'
	i=i+1
       ENDIF
	n=n-1
	GOTO 51
      CASE(2)
       CALL ParZao(Xko,Yko,Iko,Jko,Xov,Yov,Odmik,Orn)
       CALL LokZao(Tx+Xk(j),Ty+Yk(j),Xko,Yko,Iko,Jko,Orn,Odmik,1)
       RETURN
      END SELECT
      IF (Test.GT.0.005) THEN		! Zaokro`itev
       CALL LokZao(Tx+Xk(j),Ty+Yk(j),Rxo1-Rxo,Ryo1-Ryo,-Rxo,-Ryo,
     - Orn,Odmik,1)
      ELSE IF (Test.LT.-0.005) THEN	! Poi{~i presek dveh krogov
       CONTINUE
      ELSE					! Loka se ujemata v tangenti
       co=(Rxo*Rxo1-Ryo*Ryo1)/(Odmik**2)
       IF (co.LT.0.0) THEN	       ! ^e je kot 180 obravnavaj loka
	SELECT CASE(INT((Orl*2+Orl1)*Orn))
	 CASE(1,-1)		       ! Zaklju~i
	  GOTO 51
	 CASE(-3)		       ! Zaokro`itev
	  CALL LokZao(Tx+Xk(j),Ty+Yk(j),Rxo1-Rxo,Ryo1-Ryo,-Rxo,-Ryo,
     -	  Orn,Odmik,1)
	END SELECT
       ENDIF			       ! ^e je kot 0 zaklju~i
	GOTO 51
      ENDIF
      RETURN
51    Tx=Xov		       ! Zapomni si zadnjo abs. koor.
      Ty=Yov
      i=i+1
      j=j+1
      l=l+1
      RETURN
      END

***Podprogram LokZao zapi{e zaokro`itev v G kodi.****************************

      SUBROUTINE LokZao(Xs,Ys,Xza,Yza,Iza,Jza,Orn,od,m)

	INTEGER        i,j,l,tip,ka,m
	INTEGER*1      Lik(5),Likov,n
	REAL	       Xk(300),Yk(300),Ik(300),Jk(300),Tx,Ty,X(5,100),
     -		       Xza,Yza,Iza,Jza,Y(5,100),B(5,100),Xto,Yto
	CHARACTER*3    Ukaz(300)
	COMMON /Gcode/ Ukaz,Xk,Yk,Ik,Jk,i,j,l,Tx,Ty
	COMMON /GlPar/ X,Y,B,Lik,Likov,n

      ka=1
      Xto=Xs
      Yto=Ys
10    Ukaz(i+m*ka)='G02'			! Smer zaokro`itve je odvisna od orin.
      IF (Orn.EQ.1.0) THEN
       Ukaz(i+m*ka)='G03'
      ENDIF
      CALL KontrG23(Xto,Yto,Xza,Yza,Iza,Jza,od,Orn,Xov,Yov,tip,orn)
      Xk(j+1*ka)=Xov-Xto
      Yk(j+1*ka)=Yov-Yto
      Ik(l+(2-m)*ka)=Iza
      Jk(l+(2-m)*ka)=Jza
      IF (ka.EQ.0) THEN
       Tx=Xov
       Ty=Yov
       i=i+1
       j=j+1
       l=l+1
      ELSE
       Tx=Xov
       Ty=Yov
       j=j+2
       i=i+(m+1)
       l=l+(3-m)
      ENDIF
      SELECT CASE(tip)
      CASE(0)
       IF (B(1,n+1).EQ.0.0) THEN
	Ukaz(i)='G90'
	i=i+1
       ENDIF
      CASE(1)
       IF (B(1,n).EQ.0.0) THEN
	Ukaz(i)='G90'
	i=i+1
       ENDIF
*	n=n-1
      CASE(2)
       CALL ParZao(Xza,Yza,Iza,Jza,Xov,Yov,Od,Orn)
       Xto=Tx
       Yto=Ty
       ka=0
       m=0
       GOTO 10
      END SELECT
      RETURN
      END

***Podprogram ParZao izra~una parametre zaokro`itve na danem mestu.**********

      SUBROUTINE ParZao(Xko,Yko,Iko,Jko,Xov,Yov,Od,Orn)

       INTEGER*1 Lik(5),Likov,n
       REAL	 X(5,100),Y(5,100),B(5,100),flg,Xko,Yko,Iko,Jko,od
       COMMON	 /Vekt/	v1x,v1y,v2x,v2y,v1a,v2a,xo1,yo1,xo2,yo2,
     -			v1ex,v1ey,v2ex,v2ey,vo1x,vo1y,vo2x,vo2y
       COMMON	 /GlPar/ X,Y,B,Lik,Likov,n

      CALL Vektorji(X(1,n),Y(1,n),X(1,n+1),Y(1,n+1),
     -X(1,n+2),Y(1,n+2),Od,Orn)
      Iko=X(1,n+1)-Xov
      Jko=Y(1,n+1)-Yov
      Xko=xo2-Xov
      Yko=yo2-Yov
      IF (B(1,n+1).NE.0.0) THEN
       flg=1.0
       CALL ParLoka(B(1,n+1),X(1,n+1),Y(1,n+1),v2x,v2y,Od,Orn,Flg,
     - Skx,Sky,Rxo,Ryo,R,Orl)
       Xko=X(1,n+1)+Rxo-Xov
       Yko=Y(1,n+1)+Ryo-Yov
      ENDIF
      RETURN
      END

***Podprogram kontrolaG01 kontrolira, ~e je orodje na svoji poti zadelo v eno*
***izmed posplo{enih deljic in temu ustrezno skraj{a pot orodja.*************

      SUBROUTINE KontrG01(Xz,Yz,Xk,Yk,Od,Xov,Yov,tip,orn)

	INTEGER        p,o,re,pr,u,tip,tp
	INTEGER*1      Lik(5),Likov,n
	REAL	       dX,dY,dXY,xpo,ypo,Xo(4),na,sk,skmin,Xzn,Yzn,
     -		       alf,af,t,X(5,100),Y(5,100),B(5,100),orn,
     -		       fn,Skx,Sky,Rxo,Ryo,R,Orl,Rx(2),Ry(2),Yo(4),smin,
     -		       Rk(2),Xtg(4),Ytg(4),prz,se(4),st,Xpr,Ypr,flg,fl
	COMMON /GlPar/ X,Y,B,Lik,Likov,n

      fl=1.0
      fn=0.0
      tip=0
      skmin=2.0
      xpo=Xk-Xz
      ypo=Yk-Yz
      Xov=Xk
      Yov=Yk
      Xzn=Xz+xpo/SQRT(xpo**2+ypo**2)*0.004
      Yzn=Yz+ypo/SQRT(xpo**2+ypo**2)*0.004
      DO 110 p=n+1,Lik(1)+1
       dX=X(1,p+1)-X(1,p)
       dY=Y(1,p+1)-Y(1,p)
       dXY=SQRT(dX**2+dY**2)
      CALL tockaG01(Xzn,Yzn,xpo,ypo,X(1,p+1),Y(1,p+1),od,Xpr,Ypr,st,flg)
       re=0
       smin=2.0
       IF (B(1,p).EQ.0.0) THEN		   ! Daljica
	Rx(1)=-dY/dXY*od
	Ry(1)=dX/dXY*od
	Rx(2)=-Rx(1)
	Ry(2)=-Ry(1)
	DO 107 o=1,2
	 CALL PrePr(Xzn,Yzn,X(1,p)+Rx(o),Y(1,p)+Ry(o),
     -	 xpo,ypo,dX,dY,se(o),t,na)
	 IF (na.EQ.0.0) THEN
	  Xo(o)=Xzn+se(o)*xpo
	  Yo(o)=Yzn+se(o)*ypo
	  IF ((ABS(se(o)-0.5).LE.0.5).AND.(ABS(t-0.5).LE.0.5)) THEN
	   IF (se(o).LT.smin) THEN
	    re=o
	    smin=se(o)
	   ENDIF
	  ENDIF
	 ENDIF
107	CONTINUE
       ELSE				   ! Lok
	pr=1
	CALL ParLoka(B(1,p),X(1,p),Y(1,p),
     -	dX,dY,fn,orn,fl,Skx,Sky,Rxo,Ryo,R,Orl)
	CALL SreKot(dX,dY,Skx-X(1,p),Sky-Y(1,p),orl,alf)
	Rk(1)=R+od
	Rk(2)=R-od
	DO 109 o=1,2
	 IF ((R.GT.od).OR.(o.EQ.1)) THEN
	  CALL PresekLD(xpo,ypo,Xzn,Yzn,Rk(o),Skx,
     -	  Sky,fl,fl,se(pr),fl,na,se(pr+1))
	  IF (na.EQ.0.0) THEN
	   DO 108 u=0,1
	    Xo(pr+u)=Xzn+se(pr+u)*xpo
	    Yo(pr+u)=Yzn+se(pr+u)*ypo
	    prz=1.0
	    IF (o.EQ.2) THEN
	     prz=-1.0
	    ENDIF
	    Xtg(pr+u)=Xo(pr+u)+(Skx-Xo(pr+u))/Rk(o)*od*prz
	    Ytg(pr+u)=Yo(pr+u)+(Sky-Yo(pr+u))/Rk(o)*od*prz
	    CALL SreKot(Xtg(pr+u)-X(1,p),Ytg(pr+u)-Y(1,p),
     -	    Skx-X(1,p),Sky-Y(1,p),orl,af)
	    IF ((af.LE.alf).AND.(ABS(se(pr+u)-0.5).LE.0.5)) THEN
	     IF (se(pr+u).LT.smin) THEN
	      re=pr+u
	      smin=se(pr+u)
	     ENDIF
	    ENDIF
108	   CONTINUE
	  ENDIF
	  pr=pr+2
	 ENDIF
109	CONTINUE
       ENDIF
       IF (flg.EQ.0.0) THEN
	Xop=Xpr
	Yop=Ypr
	sk=st
	tp=2
       ENDIF
       IF (re.NE.0) THEN				  ! Prava re{itev
	Xop=Xo(re)
	Yop=Yo(re)
	sk=smin
	tp=1
	IF ((st.LE.se(re)).AND.(flg.EQ.0.0)) THEN	  ! Re{itev je to~ka
	 Xop=Xpr
	 Yop=Ypr
	 sk=st
	 tp=2
	ENDIF
       ENDIF
       IF ((re.NE.0).OR.(flg.EQ.0.0)) THEN		  ! Skraj{aj pot
	IF (sk.LT.skmin) THEN
	 skmin=sk
	 n=p
	 tip=tp
	 Xov=Xop
	 Yov=Yop
	ENDIF
       ENDIF
110   CONTINUE
      RETURN
      END

***Podprogram kontrolaG23 kontrolira, ~e je orodje na svoji poti zadelo v eno*
***izmed posplo{enih deljic in temu ustrezno skraj{a pot orodja.*************

      SUBROUTINE KontrG23(Xza,Yza,Xko,Yko,Iko,Jko,od,in,Xov,Yov,tip,orn)

	INTEGER        p,o,pr,re,u,tp,tip
	INTEGER*1      Lik(5),Likov,n
	REAL	       dX,dY,na,Xf,Yf,Ro,se(2),Rx(2),Ry(2),fn,Xo(4),afk,
     -		       Yo(4),alf,af(4),afmin,Xop,Yop,fl,Rk(2),af1,prz,
     -		       Xk(4),Yk(4),flg,Xpr,Ypr,aft,Xov,Yov,Xp(2),Yp(2),
     -		       X(5,100),Y(5,100),B(5,100),Skx,Sky,Rxo,Ryo,R2,
     -		       Orl,Iko,Jko,in,afkmin,afko
	COMMON /GlPar/ X,Y,B,Lik,Likov,n

      Dol(Xf,Yf)=SQRT(Xf**2+Yf**2)
      fl=1.0
      fn=0.0
      afkmin=8.0
      tip=0
      Ro=Dol(Iko,Jko)
      afko=0.004/Ro			     ! Natan~nost stroja
      Xov=Xza+Xko
      Yov=Yza+Yko
      Xso=Xza+Iko
      Yso=Yza+Jko
      CALL SreKot(Xko,Yko,Iko,Jko,in,alf)
      DO 150 p=n+1,Lik(1)+1
       pr=1
       re=0
       afmin=8.0
       dX=X(1,p+1)-X(1,p)
       dY=Y(1,p+1)-Y(1,p)
       dXY=Dol(dX,dY)
       CALL TockaG23(Xza,Yza,X(1,p+1),Y(1,p+1),Xza+Iko,Yza+Jko,
     - od,Ro,alf,in,Xpr,Ypr,flg,aft)
       IF (B(1,p).EQ.0.0) THEN		     ! Daljica
	Rx(1)=-dY/dXY*od
	Ry(1)=dX/dXY*od
	Rx(2)=Rx(1)*(-1.0)
	Ry(2)=Ry(1)*(-1.0)
	DO 140 o=1,2			     ! Najdi pravo re{itev, ~e obstaja
	 CALL PresekLD(dX,dY,X(1,p)-Rx(o),Y(1,p)-Ry(o),
     -	 Ro,Xso,Yso,fl,fl,se(1),fl,na,se(2))
	 IF (na.EQ.0.0) THEN
	  DO 139 u=0,1
	   Xo(pr+u)=X(1,p)-Rx(o)+se(u+1)*dX
	   Yo(pr+u)=Y(1,p)-Ry(o)+se(u+1)*dY
	   CALL SreKot(Xo(pr+u)-Xza,Yo(pr+u)-Yza,Iko,Jko,in,af(pr+u))
	   IF (af(pr+u).LT.afko) af(pr+u)=8.0
	   IF ((af(pr+u).LE.alf).AND.(ABS(se(u+1)-0.5).LE.0.5)) THEN
	    IF (af(pr+u).LT.afmin) THEN
	     re=pr+u
	     afmin=af(pr+u)
	    ENDIF
	   ENDIF
139	  CONTINUE
	 ENDIF
	 pr=pr+2
140	CONTINUE
       ELSE				     ! Lok
	CALL ParLoka(B(1,p),X(1,p),Y(1,p),dX,dY,fn,orn,fl,
     -	Skx,Sky,Rxo,Ryo,R2,Orl)
	CALL SreKot(dX,dY,Skx-X(1,p),Sky-Y(1,p),orl,alf1)
	Rk(1)=R2+od
	Rk(2)=R2-od
	DO 145 o=1,2
	 IF ((R2.GT.od).OR.(o.EQ.1)) THEN
	  CALL PKro(Xso,Yso,Skx,Sky,Ro,Rk(o),Xp(1),Yp(1),Xp(2),Yp(2),na)
	  IF (na.EQ.0.0) THEN
	   DO 144 u=0,1
	    Xo(pr+u)=Xp(u+1)
	    Yo(pr+u)=Yp(u+1)
	    prz=1.0
	    IF (o.EQ.2) THEN
	     prz=-1.0
	    ENDIF
	    Xk(pr+u)=Xo(pr+u)+(Skx-Xo(pr+u))/Rk(o)*od*prz
	    Yk(pr+u)=Yo(pr+u)+(Sky-Yo(pr+u))/Rk(o)*od*prz
	    CALL SreKot(Xo(pr+u)-Xza,Yo(pr+u)-Yza,Iko,Jko,in,af(pr+u))
	    CALL SreKot(Xk(pr+u)-X(1,p),Yk(pr+u)-Y(1,p),Skx-X(1,p),
     -	    Sky-Y(1,p),orl,af1)
	    IF (af(pr+u).LT.afko) af(pr+u)=8.0
	    IF ((af(pr+u).LE.alf).AND.(af1.LE.alf1)) THEN
	     IF (af(pr+u).LT.afmin) THEN
	      re=pr+u
	      afmin=af(pr+u)
	     ENDIF
	    ENDIF
144	   CONTINUE
	  ENDIF
	  pr=pr+2
	 ENDIF
145	CONTINUE
       ENDIF
       IF (flg.EQ.0.0) THEN
	Xop=Xpr
	Yop=Ypr
	afk=aft
	tp=2
       ENDIF
       IF (re.NE.0) THEN				  ! Prava re{itev
	Xop=Xo(re)
	Yop=Yo(re)
	afk=afmin
	tp=1
	IF ((aft.LE.af(re)).AND.(flg.EQ.0.0)) THEN	  ! Re{itev je to~ka
	 Xop=Xpr
	 Yop=Ypr
	 afk=aft
	 tp=2
	ENDIF
       ENDIF
       IF ((re.NE.0).OR.(flg.EQ.0.0)) THEN		  ! Skraj{aj pot
	IF (afk.LT.afkmin) THEN
	 afkmin=afk
	 Xov=Xop
	 Yov=Yop
	 tip=tp
	 n=p
	ENDIF
       ENDIF
150   CONTINUE
      RETURN
      END

      SUBROUTINE SreKot(X2,Y2,Xs,Ys,ol,alf)

	 REAL alf,X2,Y2,Xs,Ys,ol,Co,Si
	 PARAMETER(Pi=3.141593)

       Co=(-Xs*(X2-Xs)-Ys*(Y2-Ys))/(SQRT(Xs**2+Ys**2)**2)
       Si=(-Xs*(Y2-Ys)+Ys*(X2-Xs))/(SQRT(Xs**2+Ys**2)**2)
       IF ((ABS(si).GT.1.0).OR.(ABS(co).GT.1.0)) THEN
	RETURN
       ENDIF
       IF (si.LE.0.0) THEN
	alf=ACOS(Co)
       ELSE
	alf=2*Pi-ACOS(Co)
       ENDIF
       IF (ol.EQ.1) THEN     ! Dolo~itev kota med vekorji glede na orientacijo
	alf=2*Pi-alf
       ENDIF
       RETURN
       END

***Podprogram to~ka je del podprograma kontrolaG01, ki skraj{a pot orodja****
***tako, da je ogli{~e lika to~ka kro`nice.**********************************

      SUBROUTINE TockaG01(Xz,Yz,xp,yp,Xt,Yt,od,Xop,Yop,st,fl)

       REAL na,f,fl,s,st,t,Xop,Yop

      f=1.0
      CALL PresekLD(xp,yp,Xz,Yz,od,Xt,Yt,f,f,s,f,na,t)
      fl=1.0
      IF (na.EQ.0.0) THEN
       IF (ABS(s-0.5).LT.0.5) THEN	   ! Kontrola intervala
	Xop=Xz+s*xp
	Yop=Yz+s*yp
	st=s
	fl=0.0
       ENDIF
      ENDIF
      RETURN
      END

***Podprogram to~kaG23 je del podprograma kontrolaG23, ki skraj{a pot orodja*
***tako, da je ogli{~e lika to~ka kro`nice.**********************************

      SUBROUTINE TockaG23(Xz,Yz,Xt,Yt,Sxo,Syo,od,R,afa,ol,Xop,Yop,fl,at)

       INTEGER o
       REAL    na,Xp(2),Yp(2),af(2),Xop,Yop,fl,R,afa,ol,at,afmin,afko

      CALL PKro(Xt,Yt,Sxo,Syo,od,R,Xp(1),Yp(1),Xp(2),Yp(2),na)
      fl=1.0
      afmin=8.0
      afko=0.004/R
      IF (na.EQ.0.0) THEN	       ! Na poti orodja obstaja ogli{~e lika
       DO 300 o=1,2
	CALL SreKot(Xp(o)-Xz,Yp(o)-Yz,Sxo-Xz,Syo-Yz,ol,af(o))
	IF (af(o).LT.afko) af(o)=8.0
	IF (af(o).LT.afa) THEN
	 IF (af(o).LT.afmin) THEN
	  afmin=af(o)
	  Xop=Xp(o)
	  Yop=Yp(o)
	  fl=0.0
	  at=afmin
	 ENDIF
	ENDIF
300    CONTINUE
      ENDIF
      RETURN
      END

***Podprogram Meje dolo~i minimalno in maksimalno X, Y koordinato lika.******
***Izra~una tudi dol`ino in {irino lika. Parametri so potrbni za transfor.***

      SUBROUTINE Meje(Xz,Yz,dX,dY,odm,ZuNo)

       INTEGER	      i,u,pr
       INTEGER*1      Lik(5),Likov,ZuNo,n
       REAL	      Xl,Xd,Yg,Yd,fn,fl,alf,X(5,100),Y(5,100),B(5,100),
     -		      af,Xz,Yz,dX,dY,odm,odmi
       REAL	      sR(8) /-1.0,0.0,1.0,0.0,0.0,1.0,0.0,-1.0/
       COMMON /GlPar/ X,Y,B,Lik,Likov,n

      odmi=odm
      Xl=X(1,1)
      Xd=X(1,1)
      Yg=Y(1,1)
      Yd=Y(1,1)
      fn=0.0
      fl=1.0
      DO 10 i=1,Lik(1)
       CALL MinMax(X(1,i),Y(1,i),Xl,Xd,Yg,Yd)
       IF (B(1,i).NE.0.0) THEN
	CALL ParLoka(B(1,i),X(1,i),Y(1,i),X(1,i+1)-X(1,i),
     -	Y(1,i+1)-Y(1,i),fn,fl,fl,Skx,Sky,Rxo,Ryo,R,Orl)
	CALL SreKot(X(1,i+1)-X(1,i),Y(1,i+1)-Y(1,i),
     -	Skx-X(1,i),Sky-Y(1,i),orl,alf)
	pr=1
	DO 5 u=1,4
	 eTx=Skx+R*sR(pr)
	 eTy=Sky+R*sR(pr+1)
	 CALL SreKot(eTx-X(1,i),eTy-Y(1,i),Skx-X(1,i),Sky-Y(1,i),orl,af)
	 IF (af.LT.alf) THEN
	  CALL MinMax(eTx,eTy,Xl,Xd,Yg,Yd)
	 ENDIF
	 pr=pr+2
5	CONTINUE
       ENDIF
10    CONTINUE
      IF (ZuNo.EQ.50) THEN
       odmi=0.0
      ENDIF
      Xz=Xl-odmi
      Yz=Yd-odmi
      dX=Xd-Xl+2*odmi
      dY=Yg-Yd+2*odmi
      RETURN
      END

      SUBROUTINE MinMax(X,Y,Xl,Xd,Yg,Yd)

      IF (X.LT.Xl) THEN
       Xl=X
      ENDIF
      IF (X.GT.Xd) THEN
       Xd=X
      ENDIF
      IF (Y.LT.Yd) THEN
       Yd=Y
      ENDIF
      IF (Y.GT.Yg) THEN
       Yg=Y
      ENDIF
      RETURN
      END

***Podprogram Skal izra~una vrednosti skaliranja in dolo~i matriko.**********

      SUBROUTINE Skal(dX,dY,MSk,Iz,Sx,Sy)

       INTEGER*1 Iz
       REAL	 MSk(3,3),Sx,Sy

      Sx=620.0/dX		  ! Lik skaliramo na obmo~je 636*410 to~k
      Sy=399.0/dY
      IF (Iz.EQ.1) THEN 	  ! Lik ohrani proporcionalnost
       IF (Sx.GE.Sy) THEN
	Sx=Sy
       ELSE
	Sy=Sx
       ENDIF
      ENDIF
      MSk(1,1)=Sx
      MSk(2,2)=Sy
      RETURN
      END

***Podprogram Premik izra~una parametre premika tako, da je lik v koordina-**
***tnem izhodi{~u. Dolo~i tudi matriko premika.******************************

      SUBROUTINE Premik(tx,ty,MPr)

	REAL	  Mpr(3,3),tx,ty

      MPr(3,1)=tx
      MPr(3,2)=ty
      RETURN
      END

***Podprogram Comp izra~una produkt dveh matrik.*****************************

      SUBROUTINE Comp(C,A,B)

	INTEGER i,j,k
	REAL	C(3,3),A(3,3),B(3,3)

      DO 10 i=1,3
       DO 10 j=1,3
	C(j,i)=0
	DO 10 k=1,3
	 C(j,i)=C(j,i)+A(k,i)*B(j,k)
10	CONTINUE
      RETURN
      END

***Podprogram IzrisLi Izri{e transformir  an lik.******************************

      SUBROUTINE IzrisLi(MCo,Sx,Sy)

       INTEGER	      i
       INTEGER*1      Lik(5),Likov,n
       REAL	      MCo(3,3),X(5,100),Y(5,100),B(5,100),fn,fl
       COMMON /GlPar/ X,Y,B,Lik,Likov,n

      CALL gsplci(3)
      fn=0.0
      fl=1.0
      DO 10 i=1,Lik(1)
       IF (B(1,i).NE.0) THEN
	CALL ParLoka(B(1,i),X(1,i),Y(1,i),X(1,i+1)-X(1,i),
     -	Y(1,i+1)-Y(1,i),fn,fl,fl,Skx,Sky,Rxo,Ryo,R,Orl)
	CALL IzrisLok(Sx,Sy,X(1,i),Y(1,i),(X(1,i+1)-X(1,i))*Sx,
     -	(Y(1,i+1)-Y(1,i))*Sy,(Skx-X(1,i))*Sx,(Sky-Y(1,i))*Sy,Orl,MCo,R)
       ELSE
	CALL IzrisDal(X(1,i),Y(1,i),X(1,i+1),Y(1,i+1),MCo)
       ENDIF
10    CONTINUE
      RETURN
      END

      SUBROUTINE IzrToc(MCo,Xk1,Yk1,Xk2,Yk2,Xt,Yt)

       REAL Xt(2),Yt(2),MCo(3,3)

      Xt(1)=MCo(1,1)*Xk1+MCo(2,1)*Yk1+MCo(3,1)
      Yt(1)=MCo(1,2)*Xk1+MCo(2,2)*Yk1+MCo(3,2)
      Xt(2)=MCo(1,1)*Xk2+MCo(2,1)*Yk2+MCo(3,1)
      Yt(2)=MCo(1,2)*Xk2+MCo(2,2)*Yk2+MCo(3,2)
      RETURN
      END

      SUBROUTINE IzrisDal(Xk1,Yk1,Xk2,Yk2,MCo)

       REAL  Xd(2),Yd(2),MCo(3,3)

      CALL IzrToc(MCo,Xk1,Yk1,Xk2,Yk2,Xd,Yd)
      CALL gpl(2,Xd,Yd)
      RETURN
      END

      SUBROUTINE IzrisLok(Sx,Sy,Xz,Yz,Xk,Yk,Ik,Jk,Orl,MCo,R)

       REAL Xl(3),Yl(3),MCo(3,3),Ik,Jk,a,b,dfi,fi,
     -	    Xd(2),Yd(2),af1,af2
       CHARACTER*80 datrec(1) /' '/
       PARAMETER(Pi=3.141593)

      Xl(2)=MCo(1,1)*Xz+MCo(2,1)*Yz+MCo(3,1)
      Yl(2)=MCo(1,2)*Xz+MCo(2,2)*Yz+MCo(3,2)
      Xl(1)=Xl(2)+Ik
      Yl(1)=Yl(2)+Jk
      Xl(3)=Xl(2)+Xk
      Yl(3)=Yl(2)+Yk
      IF (Orl.EQ.-1.0) THEN
       Xl(3)=Xl(2)
       Yl(3)=Yl(2)
       Xl(2)=Xl(3)+Xk
       Yl(2)=Yl(3)+Yk
      ENDIF
      IF (Sx.EQ.Sy) THEN
       CALL gdp(3,Xl,Yl,-2,1,datrec)
      ELSE
       a=R*Sx
       b=R*Sy
       dfi=2/((1.5*(a+b)-SQRT(a*b))*1.3)
       CALL SreKot(Xl(2)-(Xl(1)+a),Yl(2)-Yl(1),-a,0.0,1.0,af1)
       CALL SreKot(Xl(3)-(Xl(1)+a),Yl(3)-Yl(1),-a,0.0,1.0,af2)
       IF (af2.LT.af1) af2=af2+2*Pi
       DO 10 fi=af1,af2,dfi
	Xd(1)=Xl(1)+a*COS(fi)
	Yd(1)=Yl(1)+b*SIN(fi)
	Xd(2)=Xd(1)
	Yd(2)=Yd(1)
	CALL gpl(2,Xd,Yd)
10    CONTINUE
      ENDIF
      RETURN
      END
